package com.huimv.environ.env.utils;

import cn.hutool.core.date.DateTime;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
@Slf4j
public class DateUtil {

    public Date getDateBeforeMinute(String addTime, int beforeMinute) throws ParseException {
        Calendar calendar=Calendar.getInstance();
        calendar.setTime(parseDateTime(addTime));
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE)-beforeMinute);
        return calendar.getTime();
    }

    public Date getDateBeforeMinute(int beforeMinute){
        Calendar calendar=Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE)-beforeMinute);
        return calendar.getTime();
    }

    public Date getDateAfterMinute(String addTime, int afterMinute) throws ParseException {
        Calendar calendar=Calendar.getInstance();
        calendar.setTime(parseDateTime(addTime));
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE)+afterMinute);
        return calendar.getTime();
    }

    public Date getDateAfterMinute(int afterMinute){
        Calendar calendar=Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE)+afterMinute);
        return calendar.getTime();
    }

    //Long转换为Date格式
    public String fromLongToDate(Long time ,String format) {
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        Date date = new Date(time);
        return sdf.format(date);
    }

    //格式化本年
    public String getThisYear(){
        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        return String.valueOf(year);
    }

    //格式化本月
    public String getThisMonth(){
        Calendar cal = Calendar.getInstance();
        int month = cal.get(Calendar.MONTH) + 1;
        if(String.valueOf(month).length()==1)
        {
            return "0"+String.valueOf(month);
        }else{
            return String.valueOf(month);
        }
    }

    //格式化日期时间
    public String formatDateTime(String dateText) throws ParseException {
        if(dateText.indexOf("T") != -1){
            dateText = dateText.replace("T"," ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = sdf.parse(dateText);
        return sdf.format(date);
    }

    public Date parseDateTime(String dateText) throws ParseException {
        if(dateText.indexOf("T") != -1){
            dateText = dateText.replace("T"," ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.parse(dateText);
    }

    public Long parseDateTimeLong(String dateText) throws ParseException {
        if(dateText.indexOf("T") != -1){
            dateText = dateText.replace("T"," ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = sdf.parse(dateText);
        return date.getTime();
    }

    public Date formatDate(String dateText) throws ParseException {
        if(dateText.indexOf("T") != -1){
            dateText = dateText.replace("T"," ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.parse(dateText);
    }

    public Date parseDate(Date date) throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String dateText = sdf.format(date);
        if(dateText.indexOf("T") != -1){
            dateText = dateText.replace("T"," ");
        }
        return sdf.parse(dateText);
    }

    public String formatDate(Date date) throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String dateText = sdf.format(date);
        if(dateText.indexOf("T") != -1){
            String[] dateTextArray = dateText.split("T");
            dateText = dateTextArray[0];
        }
        return dateText;
    }

    public String formatDateTime(Date date) throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateText = sdf.format(date);
        if(dateText.indexOf("T") != -1){
            String[] dateTextArray = dateText.split("T");
            dateText = dateTextArray[0];
        }
        return dateText;
    }

    //
    public Date getTodayDate() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.parse(sdf.format(new Date()));
    }

    //
    public Date getTodayDateTime() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.parse(sdf.format(new Date()));
    }

    public String getTodayDateText() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(new Date());
    }

    public String getTodayText() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(new Date());
    }

    public String getTodayMissionText() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
        return sdf.format(new Date());
    }

    public String getStartDateInThisMonth(){
        DateTime date = cn.hutool.core.date.DateUtil.date();
        return (cn.hutool.core.date.DateUtil.beginOfMonth(date) + "").substring(0, 10);
    }

    public String getEndDateInThisMonth(){
        DateTime date = cn.hutool.core.date.DateUtil.date();
        return (date + "").substring(0, 10);
    }

    /**
     * 获取过去或者未来 任意天内的日期数组
     * @param intervals      intervals天内
     * @return              日期数组
     */
    public ArrayList<String> test(int intervals ) {
        ArrayList<String> pastDaysList = new ArrayList<>();
        ArrayList<String> fetureDaysList = new ArrayList<>();
        for (int i = 0; i <intervals; i++) {
            pastDaysList.add(getPastDate(i));
            fetureDaysList.add(getFetureDate(i));
        }
        return pastDaysList;
    }

    /**
     * 获取过去第几天的日期
     *
     * @param past
     * @return
     */
    public String getPastDate(int past) {
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.DAY_OF_YEAR, calendar.get(Calendar.DAY_OF_YEAR) - past);
        Date today = calendar.getTime();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        String result = format.format(today);
        return result;
    }

    /**
     * 获取未来 第 past 天的日期
     * @param past
     * @return
     */
    public String getFetureDate(int past) {
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.DAY_OF_YEAR, calendar.get(Calendar.DAY_OF_YEAR) + past);
        Date today = calendar.getTime();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        String result = format.format(today);
        return result;
    }

    //重新构建日期
    public String rebuildDateTime(String text){
        return text.substring(0,4)+"-"+text.substring(4,6)+"-"+text.substring(6,8)+" "+text.substring(8,10)+":"+text.substring(10,12)+":"+text.substring(12,14);
    }

    public static void main(String[] args){
        DateUtil du = new DateUtil();
        //
        du.test1();
    }

    private void test1() {
        String text = "20211201104300";
//        String text = "1234567890abcd";
        String date = text.substring(0,4)+"-"+text.substring(4,6)+"-"+text.substring(6,8)+" "+text.substring(8,10)+":"+text.substring(10,12)+":"+text.substring(12,14);
        System.out.println("date="+date);
    }



}
